#include "testlib.h"

using namespace std;

typedef pair<int, int> point;

vector<int> check(vector<point> const &points, InStream &in) {
    int n = points.size();
    auto ids = in.readInts(n, 1, n, "result");
    vector<int> dist;
    for (int i = 0; i < n; i++) {
        ids[i]--;
        dist.push_back(abs(points[i].first - points[ids[i]].first) +
                       abs(points[i].second - points[ids[i]].second));
    }
    return dist;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    vector<point> pts;
    for (int i = 0; i < n; i++) {
        pts.emplace_back(inf.readInt(), inf.readInt());
    }

    auto ja = check(pts, ans), pa = check(pts, ouf);
    for (int i = 0; i < n; i++) {
        if (ja[i] < pa[i]) quitf(_wa, "Jury has a better answer for point %d", i + 1);
        if (ja[i] > pa[i]) quitf(_fail, "Participant has a better answer for point %d", i + 1);
    }

    quitf(_ok, "all checks passed");

}