// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238;
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 100100;

int n, m;
int d[N];
ll pref[N];
int x[N];
ll c[N];
ll dp[N];

ll getSum(int l, int r) {
    ll ans = pref[r];
    if (l != 0) {
        ans -= pref[l - 1];
    }
    return ans;
}

ll f(int dist) {
    int it = std::lower_bound(d, d + m, dist) - d; // >=

    ll ans = 0;
    ans += 1ll * it * dist;
    if (it != 0) {
        ans -= getSum(0, it - 1);
    }

    ans -= 1ll * (m - it) * dist;
    if (it != m) {
        ans += getSum(it, m - 1);
    }

    return ans;
}

class Function {
public:
    ll dpVal;
    int xj;
    ll from;

    Function() = default;

    Function(ll dpVal, int xj, ll from) : dpVal(dpVal), xj(xj), from(from) {}

    ll apply(int curX) {
        return dpVal + f(curX - xj);
    }
};

class Node {
public:
    int left, right;
    Node* l;
    Node* r;
    Function f;

    Node() = default;

    Node(int left, int right) : left(left), right(right), l(nullptr), r(nullptr), f(Function(-LINF, 0, 0)) {}
};

using pNode = Node*;

pNode tree = new Node(0, 1 << 25);

void add(pNode t, Function f) {
    int mid = (t->left + t->right) / 2;

    if (f.apply(mid) > t->f.apply(mid)) {
        std::swap(f, t->f);
    }

    if (t->left + 1 == t->right) {
        return;
    }

    bool cmpLeft = t->f.apply(t->left) < f.apply(t->left);
    bool cmpMid = t->f.apply(mid) < f.apply(mid);

    if (cmpLeft != cmpMid) {
        if (t->l == nullptr) {
            t->l = new Node(t->left, mid);
        }
        add(t->l, f);
    } else {
        if (t->r == nullptr) {
            t->r = new Node(mid, t->right);
        }
        add(t->r, f);
    }
}

ll get(pNode t, int x) {
    if (t == nullptr) {
        return -LINF;
    }

    ll ans = t->f.apply(x);
    int mid = (t->left + t->right) / 2;

    if (x < mid) {
        return std::max(ans, get(t->l, x));
    } else {
        return std::max(ans, get(t->r, x));
    }
}

// std::vector<Function> cht;

// ll getCHT(int curX) {
//     int l = 0, r = (int)cht.size();
//     while (r - l > 1) {
//         int mid = (l + r) / 2;

//         if (cht[mid].from > curX) {
//             r = mid;
//         } else {
//             l = mid;
//         }
//     }

//     // l -> ans
//     return cht[l].apply(curX);
// }

// ll intersect(Function f1, Function f2) {
//     bool first = f1.apply(0) < f2.apply(0);
//     int l = 0, r = 1e7 + 100;
//     while (r - l > 1) {
//         int mid = (l + r) / 2;
//         bool cur = f1.apply(mid) < f2.apply(mid);

//         if (cur != first) {
//             r = mid;
//         } else {
//             l = mid;
//         }
//     }
//     return r;
// }

// void addCHT(ll dpVal, int xj) {
//     while (!cht.empty()) {
//         ll curX = intersect(cht.back(), Function(dpVal, xj, 0));

//         if (curX < cht.back().from) {
//             cht.pop_back();
//         } else {
//             break;
//         }
//     }

//     if (cht.empty()) {
//         cht.push_back(Function(dpVal, xj, 0));
//     } else {
//         cht.push_back(Function(dpVal, xj, intersect(cht.back(), Function(dpVal, xj, 0))));
//     }
// }

void run() {
    scanf("%d%d", &n, &m);

    for (int i = 0; i < m; ++i) {
        scanf("%d", &d[i]);
    }
    for (int i = 0; i < n; ++i) {
        scanf("%d%lld", &x[i], &c[i]);
    }

    std::sort(d, d + m);

    for (int i = 0; i < m; ++i) {
        pref[i] = d[i];
        if (i != 0) {
            pref[i] += pref[i - 1];
        }
    }

    dp[0] = -c[0];
    // for (int i = 1; i < n; ++i) {
    //     dp[i] = -LINF;
    //     for (int j = 0; j < i; ++j) {
    //         smax(dp[i], -c[i] + dp[j] + f(x[i] - x[j]));
    //     }
    // }
    // addCHT(dp[0], x[0]);
    add(tree, Function(dp[0], x[0], 0));
    for (int i = 1; i < n; ++i) {
        // dp[i] = -c[i] + getCHT(x[i]);
        // addCHT(dp[i], x[i]);
        dp[i] = -c[i] + get(tree, x[i]);
        add(tree, Function(dp[i], x[i], 0));
        // debug(dp[i]);
    }

    printf("%lld\n", dp[n - 1]);
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    auto start = std::chrono::high_resolution_clock::now();
    run();
    auto end = std::chrono::high_resolution_clock::now();

    #ifdef PERVEEVM_LOCAL
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
