#include "testlib.h"

#include <string>
#include <vector>

using namespace std;

typedef long long ll;


ll getAns(InStream &stream, ll n, vector<ll> a, vector<ll> b) {
    ll ans = stream.readLong(1, 1'000'000'000'000'000'000ll, "ans");
    int ind1 = stream.readInt(1, 2, "ind_1");
    ll cnt1 = stream.readLong(0, n, "cnt_1");
    int ind2 = stream.readInt(1, 2, "ind_2");
    ll cnt2 = stream.readLong(0, n, "cnt_1");
    if (ind1 == ind2) {
        stream.quitf(_wa, "invalid index");
    }
    if (cnt1 + cnt2 != n) {
        stream.quitf(_wa, "cnt1 + cnt2 != n");
    }
    if (max(a[0] * cnt1 * b[ind1 - 1], a[1] * cnt2 * b[ind2 - 1]) != ans) {
        stream.quitf(_wa, "wrong ans");
    }

    return ans;
}

int main(int argc, char *argv[])
{
    registerTestlibCmd(argc, argv);
    ll n = inf.readLong();
    vector<ll> a(2);
    a[0] = inf.readLong();
    a[1] = inf.readLong();
    vector<ll> b(2);
    b[0] = inf.readLong();
    b[1] = inf.readLong();

    ll pa = getAns(ouf, n, a, b);
    ll ja = getAns(ans, n, a, b);
    if (pa > ja) {
        quitf(_wa, "pa > ja");
    } else if (pa < ja) {
        quitf(_fail, "pa < ja");
    }
    quitf(_ok, "OK");

    return 0;
}

